﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#Region DESIGNER PROPERTIES 

#DesignerProperty: Key: BorderSize, DisplayName: Border size, FieldType: Int, DefaultValue: 10
#DesignerProperty: Key: BorderColor, DisplayName: Border Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Border color
#DesignerProperty: Key: Color1, DisplayName: First Color, FieldType: Color, DefaultValue: 0xFFFF0000, Description: First color of gradient
#DesignerProperty: Key: Color2, DisplayName: Second Color, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Second color of gradient
#DesignerProperty: Key: Color3, DisplayName: Third Color, FieldType: Color, DefaultValue: 0xFF0000FF, Description: Third color of gradient

#End Region

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Private xui As XUI
	
	Private mBorderSize As Int = 10dip
	Private mBorderColor As Int = Colors.White
	Private mColor1, mColor2, mColor3 As Int
	Private pnlBack, pnlFore As B4XView

End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.Color = Colors.Transparent

	mBorderSize = Props.Get("BorderSize")
	mBorderColor = Props.Get("BorderColor")
	
	mColor1 = Props.Get("Color1")
	mColor2 = Props.Get("Color2")
	mColor3 = Props.Get("Color3")

	pnlBack = CreatePanel("")
	mBase.AddView(pnlBack, 0, 0, mBase.Width, mBase.Height)
	ChangeBorderColor
'	pnlBack.SetColorAndBorder(Colors.Transparent, mBorderSize, mBorderColor, mBorderSize)
''	Dim pBack As Panel = pnlBack
''	Dim cd As ColorDrawable
''	cd.Initialize(mBorderColor, mBorderSize)
''	pBack.Background = cd
''	pnlBack = pBack

	
	pnlFore = CreatePanel("pnlFore")
	pnlBack.AddView(pnlFore, mBorderSize, mBorderSize, mBase.Width - mBorderSize * 2, mBase.Height - mBorderSize * 2)
'	Dim pFore As Panel = pnlFore
'	Dim gdb As GradientDrawable
'	Dim GradColors(3) As Int = Array As Int(mColor1, mColor2, mColor3)
'	gdb.Initialize("TOP_BOTTOM", GradColors)
'	gdb.CornerRadius = 10dip
'	pFore.Background = gdb
'	pnlFore = pFore
	ChangeGradientColors
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
End Sub

#Region + PROPERTIES 

Public Sub setFirstColor(Col As Int)
	mColor1 = Col
	ChangeGradientColors
End Sub
Public Sub getFirstColor As Int
	Return mColor1
End Sub

Public Sub setSecondColor(Col As Int)
	mColor2 = Col
	ChangeGradientColors
End Sub
Public Sub getSecondColor As Int
	Return mColor2
End Sub

Public Sub setThirdColor(Col As Int)
	mColor3 = Col
	ChangeGradientColors
End Sub
Public Sub getThirdColor As Int
	Return mColor3
End Sub

Public Sub setBorderColor(Col As Int)
	mBorderColor = Col
	ChangeBorderColor
End Sub
#End Region

#Region + METHODS 

#Region + PUBLIC METHODS 
#End Region

#Region + PRIVATE METHODS 

Private Sub CreatePanel (PanelEventName As String) As B4XView
	Return xui.CreatePanel(PanelEventName)
End Sub

Private Sub ChangeGradientColors
	Dim pFore As Panel = pnlFore
	Dim gdb As GradientDrawable
	Dim GradColors(3) As Int = Array As Int(mColor1, mColor2, mColor3)
	gdb.Initialize("TOP_BOTTOM", GradColors)
	gdb.CornerRadius = mBorderSize
	pFore.Background = gdb
	pnlFore = pFore
End Sub

Private Sub ChangeBorderColor
	Dim pBack As Panel = pnlBack
	Dim cd As ColorDrawable
	cd.Initialize(mBorderColor, mBorderSize)
	pBack.Background = cd
	pnlBack = pBack
End Sub

#End Region

#End Region

